<template>
	<f7-page 
        name="residentreport" 
        @page:beforein="onPageBeforeIn"
        @page:beforeout="onPageBeforeOut"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Aduan">
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">{{ currentCategory }}</f7-nav-title>
            <f7-nav-right>
                <f7-link href="/resident-reports/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>

		<!-- Page content-->
        <f7-block v-if="residentReportCategories.length > 0">
			<f7-toolbar tabbar scrollable position="top" no-shadow no-hairlines class="no-background" style="top:0;">
                <f7-link @click="handleResidentReportCategory('semua')" :class="`gradient-box${slugify(currentCategory) == 'semua' ? ' tab-link-active' : ''}`">
					<span class="">Semua</span>									
				</f7-link>
				<f7-link @click="handleResidentReportCategory(item.slug)" :class="`gradient-box${slugify(currentCategory) == item.slug ? ' tab-link-active' : ''}`" v-for="(item, index) in residentReportCategories" :key="index">
					<span class="">{{ item.name }}</span>									
				</f7-link>
                <f7-link @click="handleResidentReportCategory('aduan-saya')" :class="`gradient-box${slugify(currentCategory) == 'aduan-saya' ? ' tab-link-active' : ''}`">
					<span class="">Aduan Saya</span>									
				</f7-link>
			</f7-toolbar>
		</f7-block>
        <f7-list media-list no-hairlines v-if="!residentReportLoading && residentreports.length > 0">
            <f7-list-item
                v-for="(item, index) in residentreports"
                :key="index"
                :after="hoursAgo(item.created)"
                :title="item.category.name"
                :subtitle="item.title"
                :text="truncate(stripHTML(item.body))"
                :data-residentreport="JSON.stringify(item)"
            >
                <img v-if="item.author.profile.media != null" :src="item.author.profile.media.url.small" width="48" height="48" class="img-circle" slot="media"/>
                <div v-else :data-initial-medium="item.author.profile.initial" slot="media"></div>
            </f7-list-item>
            
        </f7-list>
        <f7-block v-else-if="!residentReportLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="volume_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
        <f7-list media-list no-hairlines v-if="residentReportLoading">
            <f7-list-item
                v-for="n in 4"
                :key="n"
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Position"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { hoursAgo, dateFormat, truncate, stripHTML, slugify, parseError } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'ResidentReport',
    data(){
        return {
            residentReportLoading: true,
            allowInfinite: true,
            showPreloader: true,
            currentCategory: 'Semua',
            currentCategoryId: null,
            authorId: null
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('category', ['residentReportCategories']),
		...mapGetters('residentreport', [
			'residentreports',
			'pagination'
		])
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;

        $$('div[data-name="residentreport"]').on('click', '.media-list li', function(){
            let residentreport = JSON.parse($$(this).data('residentreport'));
            
            if(residentreport.author.id == self.user.id && self.currentCategory == 'Aduan Saya'){
                self.showActionSheet(residentreport);
            }else{
                self.$f7router.navigate('/resident-reports/view/'+residentreport.id+'/', {
                    ignoreCache: true
                });
            }
        });
    },
    methods: {
        hoursAgo,
        dateFormat,
        truncate,
        stripHTML,
        slugify,
        getCategories(){
			const self = this;
			const app = self.$f7;

			self.$store.dispatch('category/getCategories', {
				module: 'residentreport',
				page: 1,
                perpage: 100,
                only: 'id,name,slug'
			});
		},
        getResidentReports(page, loadmore){
			const self = this;
            const app = self.$f7;
            
			self.$store.dispatch('residentreport/getResidentReports', {
				status: 'publish',
				page: page,
                perpage: 25,
                loadmore: loadmore,
                category: self.currentCategoryId,
                author: self.authorId,
                only: 'id,number,title,body,created,updated,category.id,category.name,medias.mimetype,medias.url,medias.filename,medias.original_filename,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'
			}).then(() => {                
                setTimeout(() => {
                    self.showPreloader = self.pagination.has_next;
                    self.residentReportLoading = false;
                }, 100);
            });
		},
        onPageBeforeIn(){
            const self = this;

            self.getCategories();
            self.getResidentReports(1, false);
        },       
        onPageBeforeOut(page){
            const self = this;

            if(page.detail.name == 'residentreport'){
                self.currentCategory = 'Semua';
                self.currentCategoryId = null;
                self.authorId = null;
                self.$store.dispatch('category/resetCategories', {
                    module: 'residentreport'
                });
                self.$store.dispatch('residentreport/resetResidentReports');
            }
        },
        onPageRefresh(e, done){
            const self = this;

            self.$store.dispatch('category/resetCategories', {
                module: 'residentreport'
            }).then(()=>{
                self.financialReportLoading = false;
                self.getCategories();
            });

            self.getResidentReports(1, false);
            done();
            
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getResidentReports(self.pagination.page + 1, true);
                    self.allowInfinite = true;                 
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        handleResidentReportCategory(category){
			const self = this;
            const app = self.$f7;
            
            self.residentReportLoading = true;
            
            if(['semua', 'aduan-saya'].indexOf(category) == -1){                
                for(const x of self.residentReportCategories){
                    if(x.slug == category){
                        self.currentCategory = x.name;
                        self.currentCategoryId = x.id;
                        break;
                    }
                }

                self.authorId = null;

            }else if(category == 'aduan-saya'){
                self.authorId = self.user.id;
                self.currentCategoryId = null;
                self.currentCategory = 'Aduan Saya';
            }else{
                self.authorId = null;
                self.currentCategoryId = null;
                self.currentCategory = 'Semua';
            }

            self.$store.dispatch('residentreport/resetResidentReports').then(()=>{
                self.getResidentReports(1, false);
            });            
        },
        showActionSheet(residentreport){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: residentreport.title,
                label: true
            }, {
                text: 'Lihat',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/resident-reports/view/'+residentreport.id+'/', {
                        ignoreCache: true
                    });
                }
            }, {
                text: 'Ubah',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/resident-reports/edit/'+residentreport.id+'/', {
                        ignoreCache: true
                    });
                }
            }, {
                text: 'Hapus',
                close: true,
                onClick: function(actions, e){
                    app.dialog.confirm('Anda yakin ingin menghapus aduan ini?', function(){
                        app.preloader.show('green');
                        self.$store.dispatch('residentreport/deleteResidentReport', {
                            id: residentreport.id,
                            only: 'id,number,title,body,created,updated,category.id,category.name,medias.mimetype,medias.url,medias.filename,medias.original_filename,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'
                        }).then((response)=>{
                            app.preloader.hide();

                            if('errors' in response){
                                let error = parseError(response.errors);
                                app.dialog.alert(error.messages, 'RingSatu');
                                return false;
                            }else{
                                self.authorId = self.user.id;
                                self.currentCategoryId = null;
                                self.currentCategory = 'Aduan Saya';

                                self.$store.dispatch('residentreport/resetResidentReports').then(()=>{
                                    self.getResidentReports(1, false);
                                }); 
                            } 
                        });
                    });
                }
            }, {
                text: 'Batal',
                color: 'red',
                close: true
            }];

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
      
        },
    }
}
</script>
